#!/usr/bin/env python

from openlookup.client.singleton import Proxy
from openlookup.client.keychain import KeyChain, NotFound, Ambiguous
import sys

BLOCK_SIZE = 8192

def downloadblocks(template, principal, length, count=1):
    block = p.get(template % str(count), principal)
    if length < BLOCK_SIZE:
        return block[:length]
    return block + downloadblocks(template, principal, length - BLOCK_SIZE, count + 1)


if len(sys.argv) < 2:
    print './getfile.py FILENAME'
    sys.exit()

filename = sys.argv[1]


p = Proxy()

keychain = KeyChain()
principal = keychain.find('').hexdigest()

template = 'qfriendslol-%s-' + filename

length = int(p.get(template % '0', principal))

data = downloadblocks(template, principal, length)

f = open(filename,'w')
f.write(data)
f.close()


