#!/usr/bin/python2.6
# -*- coding: utf-8 -*-

import sys
from PyQt4 import Qt

def panelify(layout):
    panelWidget = Qt.QWidget()
    panelWidget.setLayout(layout)
    return panelWidget 

def getMugshot(userid = None):
    import os.path
    dir = os.path.dirname(__file__)
    if userid == None:
        picUrl = dir + '/graphics/mugshot_new.svg'
    else:
        picUrl = dir + '/graphics/mugshot_unknown.svg'

    picture = Qt.QLabel()
    pictureImage = Qt.QPixmap.fromImage(Qt.QImage(picUrl))
    picture.setPixmap(pictureImage)
    return picture

def mainWindow():
    import os.path
    dir = os.path.dirname(__file__)
    icon = Qt.QIcon(dir + '/graphics/qfriendslol_logo.svg')

    window = Qt.QMainWindow()
    window.setWindowTitle(u'QFriendsLOL')
    window.setWindowIcon(icon)

    applicationTabs = Qt.QTabWidget()

    createTabItems(applicationTabs)

    window.setCentralWidget(applicationTabs)

    return window

def createTabItems(tabWidget):
    homeTab(tabWidget)
    friendTab(tabWidget, 'Frank')
    friendTab(tabWidget, 'F684A')
    newFriendTab(tabWidget)

def homeTab(tabWidget):
    import os.path
    dir = os.path.dirname(__file__)
    icon = Qt.QIcon(dir + '/graphics/qfriendslol_home.svg')
    nameOfTab = u'&Home'
    contentOfTab = homeTabContent()
    tabWidget.addTab(contentOfTab, icon, nameOfTab)

def homeTabContent():
    layout = Qt.QVBoxLayout()
    layout.addStretch(1)
    layout.setMargin(1)
    layout.addWidget(userInfo())
    layout.addWidget(fileUpload())
    layout.addWidget(getFileList())
    return panelify(layout)

def friendTab(tabWidget, name):
    import os.path
    dir = os.path.dirname(__file__)
    icon = Qt.QIcon(dir + '/graphics/mugshot_unknown.svg')
    nameOfTab = u'%s' % name
    contentOfTab = friendTabContent(name)
    tabWidget.addTab(contentOfTab, icon, nameOfTab)

def friendTabContent(userid):
    layout = Qt.QVBoxLayout()
    layout.addStretch(1)
    layout.setMargin(1)
    layout.addWidget(userInfo(userid))
    layout.addWidget(getFileList(userid))
    return panelify(layout)

def userInfo(userid = None):
    layout = Qt.QHBoxLayout()
    layout.setMargin(1)
    #layout.addStretch(1)

    picture = getMugshot(1)

    dataLayout = Qt.QVBoxLayout()
    dataLayout.setMargin(1)
    dataLayout.addStretch(1)
    if userid == None:
        dataLayout.addWidget(Qt.QLabel(u'645324AF324'))
        dataLayout.addWidget(Qt.QLineEdit(u'me@localhost'))
        forget = Qt.QPushButton(u'Change')
    else:
        dataLayout.addWidget(Qt.QLabel(u'645324AF324'))
        dataLayout.addWidget(Qt.QLabel(u'frank@gmail.com'))
        forget = Qt.QPushButton(u'Forget')

    layout.addWidget(picture)
    layout.addWidget(panelify(dataLayout))
    layout.addWidget(forget)

    return panelify(layout)

def fileUpload():
    return Qt.QLabel(u'File uploading')

def getFileList(userid = None):
    files = ['forest.jpg', 'kitten.jpg', 'lolcat1.jpg', 'lolcat2.jpg',
            'catlollerz.gif']
    fileListTable = Qt.QTableWidget()
    fileListTable.setColumnCount(5)
    fileListTable.setSortingEnabled(True)
    fileListTable.setShowGrid(False)
    fileListTable.setHorizontalHeaderLabels([u'File', u'Size', u'Expiration',
    u'Progress', u''])

    for file in files:
        setFileItem(fileListTable, file)
        pass

    return fileListTable

def setFileItem(table, fileData):
    row = table.rowCount()
    table.insertRow(row)
    #vertItem = Qt.QTableWidgetItem()
    #vertItem.hide()
    #table.setVerticalHeaderItem(row, vertItem)
    table.setItem(row, 0, Qt.QTableWidgetItem(u'%s' % fileData))
    table.setCellWidget(row, 0, Qt.QPushButton(u'Download'))

def newFriendTab(tabWidget):
    layout = Qt.QVBoxLayout()
    layout.addStretch(1)
    layout.setMargin(1)
    layout.addWidget(friendSearch())
    layout.addWidget(friendSearchResult())

    nameOfTab = u'+'
    contentOfTab = panelify(layout)
    tabWidget.addTab(contentOfTab, nameOfTab)

def friendSearch():
    searchBoxLayout = Qt.QHBoxLayout()

    picture = getMugshot()

    searchBox = Qt.QVBoxLayout()
    searchBox.addStretch(1)
    searchBox.addStretch(2)
    searchBox.addWidget(Qt.QLabel(u'Enter email or user id:'))
    searchBox.addWidget(Qt.QLineEdit())

    addButton = Qt.QPushButton(u'Add')

    searchBoxLayout.addWidget(picture)
    searchBoxLayout.addWidget(panelify(searchBox))
    searchBoxLayout.addWidget(addButton)
    return panelify(searchBoxLayout)

def friendSearchResult():
    searchResultsFrame = Qt.QScrollArea()

    searchResults = Qt.QVBoxLayout()
    searchResults.setMargin(1)
    searchResults.setSpacing(0)
    for userId in ['123123213A213123H123', '12312323123ADADADAD123', 'AHJQWRQRSADASD', 'ASDASDASDASD', '1231239812839123']:
        searchResults.addWidget(friendSearchResultItem(userId))

    searchResultsFrame.setWidget(panelify(searchResults))
    return searchResultsFrame

def friendSearchResultItem(userId):
    resultItem = Qt.QHBoxLayout()

    resultItem.setMargin(5)

    picture = getMugshot(id)

    userData = Qt.QVBoxLayout()
    userData.addStretch(1)
    userData.setMargin(0)
    userData.setSpacing(0)
    userIdLabel = Qt.QLabel(u'%s' % userId)
    email = Qt.QLabel(u'frank@gmail.com')
    userData.addWidget(userIdLabel)
    userData.addWidget(email)

    addButton = Qt.QPushButton(u'Add')

    resultItem.addWidget(picture)
    resultItem.addWidget(panelify(userData))
    resultItem.addWidget(addButton)

    return panelify(resultItem)

if __name__ == '__main__':
    app = Qt.QApplication(sys.argv)
    window = mainWindow()
    window.show()
    app.exec_()
