#!/usr/bin/env python

from openlookup.client.singleton import Proxy
from openlookup.client.keychain import KeyChain, NotFound, Ambiguous
import sys

BLOCK_SIZE = 8192

def uploadblocks(template, principal, data, count=1):
    if len(data) < BLOCK_SIZE:
        block = data
        remain = ''
    else:
        block = data[:BLOCK_SIZE]
        remain = data[BLOCK_SIZE:]
    p.put(template % str(count), block, principal)
    if len(remain) > 0:
        uploadblocks(template, principal, remain, count + 1)

if len(sys.argv) < 2:
    print './putfile.py FILENAME'
    sys.exit()

filename = sys.argv[1]

f = open(filename)
data = f.read()
f.close()

length = len(data)

p = Proxy()

keychain = KeyChain()
principal = keychain.find('')

template = 'qfriendslol-%s-' + filename

p.put(template % 0, str(length), principal)

uploadblocks(template, principal, data)

